#include "file.h"

int ReadMAS()
{
	FILE *f;
	char buf[256];

	wsprintf(buf,"DATA\\surface1.txt");

	f=fopen(buf,"r");

	lstrcpy(erbuf,buf);

	if (f==NULL) return 1;

	max_animat_surf=-1;

	do
	{
		max_animat_surf++;
		fgets(max_animat[max_animat_surf],256,f);
		max_animat[max_animat_surf][lstrlen(max_animat[max_animat_surf])-1]=0;
	}while (!feof(f));

	fclose(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"ANIMATE SURFACES = %d on Loading\n",max_animat_surf);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadSound()
{
	FILE *f;
	char buf[256];

	wsprintf(buf,"DATA\\sound.plm");

	f=fopen(buf,"r");

	lstrcpy(erbuf,buf);

	if (f==NULL) return 1;

	max_text_sound=-1;

	do
	{
		max_text_sound++;
		fgets(text_sound[max_text_sound],256,f);
		text_sound[max_text_sound][lstrlen(text_sound[max_text_sound])-1]=0;
	}while (!feof(f));

	fclose(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"SOUNDS = %d on Loading\n",max_text_sound);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadMenuP()
{
	FILE *f;
	char buf[256];

	wsprintf(buf,"DATA\\int.plm");

	f=fopen(buf,"r");

	lstrcpy(erbuf,buf);

	if (f==NULL) return 1;

	max_text_pic_m=-1;

	do
	{
		max_text_pic_m++;
		fgets(text_pic_m[max_text_pic_m],256,f);
		text_pic_m[max_text_pic_m][lstrlen(text_pic_m[max_text_pic_m])-1]=0;
	}while (!feof(f));

	fclose(f);
	
	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"MAX MENU PICTURES = %d on Loading\n",max_text_pic_m);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}


int ReadPalitra(int level)
{
	FILE *f;
	char buf[256];

	wsprintf(buf,"DATA\\lev_pal.plm");

	f=fopen(buf,"r");

	lstrcpy(erbuf,buf);

	if (f==NULL) return 1;

	max_text_pic=-1;

	do
	{
		max_text_pic++;
		fgets(text_pic[max_text_pic],256,f);
		text_pic[max_text_pic][lstrlen(text_pic[max_text_pic])-1]=0;
	}while (!feof(f));

	fclose(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"MAX PICTURES = %d on Loading\n",max_text_pic);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadSurfaceFile(int level)
{
	HANDLE f;
	char buf[256];
	BYTE b;
	DWORD r;

	wsprintf(buf,"LEV\\lev%i_s.mkl",level);

	lstrcpy(erbuf,buf);

	f=CreateFile(buf,GENERIC_READ,FILE_SHARE_READ |
		FILE_SHARE_WRITE,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);

	if (f==INVALID_HANDLE_VALUE) return 5;

	ReadFile(f,&b,1,&r,0);levx=b;
	ReadFile(f,&b,1,&r,0);levy=b;
	ReadFile(f,&levelbuf,levx*levy,&r,0);

	CloseHandle(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"Loading level %d. X=%d.Y=%d.\n",level,levx,levy);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadTypeBuild()
{
	char buf[256];
	FILE *f;
	f=fopen("DATA\\build.txt","r");
	lstrcpy(erbuf,"DATA\\build.txt");

	if (f==NULL) return 1;

	int k,i,d;
	k=0;
	max_type_build=0;
	do
	{
		fgets(buf,256,f);
		buf[lstrlen(buf)-1]=0;
		if (k==0) {
			i=(BYTE)(buf[1]-'0')*100+(BYTE)(buf[2]-'0')*10+(BYTE)(buf[3]-'0');
			max_type_build++;
		}
		if (k==1) lstrcpy(type_build[i].name,buf);
		if (k==2) lstrcpy(type_build[i].bmp,buf);
		if (k>2) d=atol(buf);
		switch (k)
		{
		case 3:
			type_build[i].xSize=d;break;
		case 4:
			type_build[i].ySize=d;break;
		case 5:
			type_build[i].xReal=d;break;
		case 6:
			type_build[i].yReal=d;break;
		case 7:
			type_build[i].h=d;break;
		case 8:
			type_build[i].energy=d;break;
		case 9:
			type_build[i].Ochki=d;break;
		}
		k++;
		if (k==10) k=0;
	}while (!feof(f));
	fclose(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"MAX BUILDS = %d on Loading\n",max_type_build);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadLevelBuild(int level)
{
	HANDLE f;
	char buf[256];
	BYTE b,lx,ly;
	DWORD r;
	WORD i,j;

	wsprintf(buf,"LEV\\lev%i_b.mkl",level);


	lstrcpy(erbuf,buf);

	f=CreateFile(buf,GENERIC_READ,FILE_SHARE_READ |
		FILE_SHARE_WRITE,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);

	if (f==INVALID_HANDLE_VALUE) return 5;

	ReadFile(f,&lx,1,&r,0);
	ReadFile(f,&ly,1,&r,0);
	max_build=0;
	for(i=0;i<lx*ly;i++)
	{
		ReadFile(f,&b,1,&r,0);
		if (b>0)
		{
			build[max_build].type=b-1;
			build[max_build].x=i%lx;
			build[max_build].y=i/lx;
			build[max_build].energy=type_build[b-1].energy;
			for(j=0;j<20;j++) build[max_build].r[j]=0;
			max_build++;
		}
	}

	CloseHandle(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"Loading %d builds in level %d\n",max_build,level);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadTypeObject()
{
	char buf[256];
	FILE *f;

	lstrcpy(erbuf,"DATA\\object.txt");
	f=fopen("DATA\\object.txt","r");

	if (f==NULL) return 1;

	int k,i,d;
	k=0;
	max_type_object=0;
	do
	{
		fgets(buf,256,f);
		buf[lstrlen(buf)-1]=0;
		if (k==0) {
			i=(BYTE)(buf[1]-'0')*100+(BYTE)(buf[2]-'0')*10+(BYTE)(buf[3]-'0');
			max_type_object++;
		}
		if (k==1) lstrcpy(type_object[i].name,buf);
		if (k==2) lstrcpy(type_object[i].bmp[0],buf);
		if (k==3) lstrcpy(type_object[i].bmp[1],buf);
		if (k==4) lstrcpy(type_object[i].bmp1,buf);
		if (k==5) lstrcpy(type_object[i].bmp2,buf);
		if (k>5) d=atol(buf);
		switch (k)
		{
		case 6:
			type_object[i].xSize=d; break;
		case 7:
			type_object[i].ySize=d; break;
		case 8:
			type_object[i].xReal=d; break;
		case 9:
			type_object[i].yReal=d; break;
		case 10:
			type_object[i].h=d; break;
		case 11:
			type_object[i].Health=d; break;
		case 12:
			type_object[i].Speed=d; break;
		case 13:
			type_object[i].Mobility=d; break;
		case 14:
			type_object[i].Bb=d; break;
		case 15:
			type_object[i].Gun=d; break;
		case 16:
			type_object[i].Ochki=d; break;
		}
		k++;
		if (k==17) k=0;
	}while (!feof(f));
	fclose(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"MAX OBJECTS = %d on Loading\n",max_type_object);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadHeroy(int level)
{
	char buf[1000];
	FILE *f;

	wsprintf(buf,"DATA\\type.txt",level);

	lstrcpy(erbuf,buf);
	f=fopen(buf,"r");

	if (f==NULL) return 1;

	int k,i,d;
	k=0;
	int nf=1;
	int nf1;
	//max_object=0;
	//ObjectHeroy=0;
	max_type_rot=-1;
	i=0;
	do
	{
		fgets(buf,1000,f);
		buf[lstrlen(buf)-1]=0;
		d=atol(buf);
		if (k>-1)
		{
			//   
			if (nf==1)
			{
				if (max_type_rot==-1) {
					max_type_rot=d;
					nf1=k;
				}
				else type_rot[k-nf1-1]=d;
			}
		}
		k++;
	}while (!feof(f));
	fclose(f);
	//object[i].redblue=1;
	//for(d=0;d<20;d++) object[i].r[d]=0;
	//max_object=1;

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"Loading %d type of rotate\n",max_type_rot);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

//  
int ReadSur()
{
	char buf[256];
	FILE *f;
	lstrcpy(erbuf,"DATA\\surface.txt");
	f=fopen("DATA\\surface.txt","r");

	if (f==NULL) return 1;

	max_sur=0;
	int i;

	do
	{
		fgets(buf,256,f);
		buf[lstrlen(buf)-1]=0;
		lstrcpy(sur[max_sur].bmp,buf);
		fgets(buf,256,f);
		buf[lstrlen(buf)-1]=0;
		for(i=0;i<4;i++) sur[max_sur].b[i]=buf[i]-'0';
		for(i=0;i<4;i++) if (sur[max_sur].b[i]!=1) sur[max_sur].b[i]=0;
		max_sur++;
	}while (!feof(f));
	fclose(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"PROPERTY SURFACE = %d on Loading\n",max_sur);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadTypeGun()
{
	char buf[256];
	FILE *f;

	lstrcpy(erbuf,"DATA\\gun.txt");
	f=fopen("DATA\\gun.txt","r");

	if (f==NULL) return 1;

	int k,i,d;
	k=0;
	max_type_gun=0;
	do
	{
		fgets(buf,256,f);
		buf[lstrlen(buf)-1]=0;
		if (k==0) {
			i=(BYTE)(buf[1]-'0')*100+(BYTE)(buf[2]-'0')*10+(BYTE)(buf[3]-'0');
			max_type_gun++;
		}
		if (k==1) lstrcpy(type_gun[i].name,buf);
		if (k==2) lstrcpy(type_gun[i].bmp[0],buf);
		if (k==3) lstrcpy(type_gun[i].bmp[1],buf);
		if (k>3) d=atol(buf);
		switch (k)
		{
		case 4:
			type_gun[i].Speed=d; break;
		case 5:
			type_gun[i].Force=d; break;
		case 6:
			type_gun[i].obl=d; break;
		case 7:
			type_gun[i].r[0]=d; break;
		case 8:
			type_gun[i].r[1]=d; break;
		case 9:
			type_gun[i].r[2]=d; break;
		}
		k++;
		if (k==10) k=0;
	}while (!feof(f));
	fclose(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"GUNS = %d on Loading\n",max_type_gun);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadObject(int level)
{
	char buf[256],buf1[4];
	FILE *f;

	wsprintf(buf,"LEV\\lev%i_o.txt",level);

	lstrcpy(erbuf,buf);
	f=fopen(buf,"r");

	if (f==NULL) return 1;

	int i,d;
	i=0;d=0;
	int rot=1800;

	do
	{
		fgets(buf,256,f);
		buf[lstrlen(buf)-1]=0;
		d=atol(buf);
		if (i<6) POAV[i]=d;
		if (i==6) max_object=d+1;//     
		if (i>6 && i<max_object+6)
		{
			object[i-6].on_off=false;
			object[i-6].type=d;
			object[i-6].number=i-6;
			object[i-6].redblue=0;
			for(d=0;d<20;d++) object[i-6].r[d]=0;
			object[i-6].Bmp=0;
			object[i-6].gun1=-1;object[i-6].gun2=-1;object[i-6].gun3=-1;
			object[i-6].Health=type_object[object[i-6].type].Health;
			object[i-6].x=0;
			object[i-6].y=0;
			object[i-6].Rotat_1=rot;
			object[i-6].Rotat_2=rot;
			rot+=900;
			if (rot==3600) rot=0;
		}
		i++;
	}while (!feof(f));
	fclose(f);

	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"Loading %d objects\n",max_object);
	fputs(blog,flog);
	fclose(flog);
	}

	return 0;
}

int ReadText()
{
	char buf[256];
	FILE *f;
	lstrcpy(buf,"DATA\\text.txt");

	lstrcpy(erbuf,buf);
	f=fopen(buf,"r");

	if (f==NULL) return 1;

	int i;
	for(i=0;i<MAX_TEXT;i++) text[i][0]=0;
	i=0;
	do
	{
		fgets(buf,256,f);buf[lstrlen(buf)-1]=0;
		Posit1(i,buf);
		Posit2(i,buf);
		i++;
	}while (!feof(f));
	fclose(f);
	//log
	if (fflog==1){
	char blog[256];
	flog=fopen("game.log","a");
	wsprintf(blog,"MAX TEXTS = %d on Loading\n",i);
	fputs(blog,flog);
	fclose(flog);
	}
	return 0;
}

void Posit1(int n,char *buf)
{
	char b[256];
	int i,k;
	k=0;
	for(i=0;i<lstrlen(buf);i++)
	{
		if (buf[i]=='=')
		{
			k=1;
			b[i]=0;
			break;
		}
		b[i]=buf[i];
	}
	lstrcpy(text[n],b);
}

void Posit2(int n,char *buf)
{
	char b[256];
	int i,k,l;
	k=0;
	for(i=0;i<lstrlen(buf);i++)
	{
		if (k==1) b[i-l]=buf[i];
		if (buf[i]=='=' && k==0)
		{
			k=1;
			l=i+1;
		}
	}
	b[i-l]=0;
	lstrcpy(text_txt[n],b);
}


int ReadHeroy1(int level)
{
	char buf[1000];
	FILE *f;

	wsprintf(buf,"LEV\\lev%i_h.txt",level);

	lstrcpy(erbuf,buf);
	f=fopen(buf,"r");

	if (f==NULL) return 1;

	int k,i,d;
	k=3;
	int nf=0;
	int nf1;
	max_object=0;
	ObjectHeroy=0;
	i=0;
	do
	{
		fgets(buf,1000,f);
		buf[lstrlen(buf)-1]=0;
		if (k==0) lstrcpy(zd,buf);
		if (k==1) lstrcpy(zd1,buf);
		if (k>1) d=atol(buf);
		switch (k)
		{
		case 2:
			object[i].type=d; break;
		case 3:
			object[i].x=d; break;
		case 4:
			object[i].y=d; break;
		case 5:
			object[i].Rotat_1=d; break;
		case 6:
			object[i].Rotat_2=d; break;
		case 7:
			object[i].Bmp=d; break;
		case 8:
			object[i].gun1=d; break;
		case 9:
			object[i].gun2=d; break;
		case 10:
			object[i].gun3=d; break;
		case 11:
			object[i].Health=d; break;
		}
		k++;
	}while (!feof(f));
	fclose(f);
	object[i].redblue=1;
	for(d=0;d<20;d++) object[i].r[d]=0;
	object[i].on_off=true;
	max_object=1;
	return 0;
}
