#include "input.h"


char* Klavi(int kl);

int DirectInputC(HWND h)
{
	// DirectInput - 
	r=DirectInputCreate(hInst,DIRECTINPUT_VERSION,&dinput,NULL);
	if (r!=DI_OK) return 1;
	r=dinput->CreateDevice(GUID_SysKeyboard,&keyboard,0);
	if (r!=DI_OK) return 2;
	r=keyboard->SetDataFormat(&c_dfDIKeyboard);
	if (r!=DI_OK) return 3;
	r=keyboard->SetCooperativeLevel(h,DISCL_FOREGROUND | 
		                            DISCL_NONEXCLUSIVE | DISCL_NOWINKEY);
	if (r!=DI_OK) return 4;
	r=dinput->CreateDevice(GUID_SysMouse,&mouse,0);
	if (r!=DI_OK) return 5;
	r=mouse->SetDataFormat(&c_dfDIMouse);
	if (r!=DI_OK) return 6;
	r=mouse->SetCooperativeLevel(h,DISCL_FOREGROUND | 
		                            DISCL_NONEXCLUSIVE);
	if (r!=DI_OK) return 7;

	//r=mouse->Acquire();
	//if (FAILED(r)) return 8;
	DIPROPDWORD dp;
	dp.diph.dwSize=sizeof(DIPROPDWORD);
	dp.diph.dwHeaderSize=sizeof(DIPROPHEADER);
	dp.diph.dwObj=0;
	dp.diph.dwHow=DIPH_DEVICE;
	dp.dwData=64;
	r=mouse->SetProperty(DIPROP_BUFFERSIZE,&(dp.diph));
	if (r!=DI_OK) return 10;
	return 0;
}

int DirectActive()
{
	if (keyboard) r=keyboard->Acquire();
	while( r == DIERR_INPUTLOST || 
                   r == E_ACCESSDENIED  ) 
        {
                r = keyboard->Acquire();
        }
	if (r!=DI_OK) return 1;
	if (mouse) r=mouse->Acquire();
	while( r == DIERR_INPUTLOST || 
                   r == E_ACCESSDENIED  ) 
        {
                r = mouse->Acquire();
        }
	if (r!=DI_OK) return 1;
	return 0;
}

int DirectDeActive()
{
	if (mouse) 
	{
		mouse->Unacquire();
		mouse->Release();
		mouse=NULL;
	}
	if (keyboard) 
	{
		keyboard->Unacquire();
		keyboard->Release();
		keyboard=NULL;
	}
	if (dinput)
	{
		dinput->Release();
	    dinput=NULL;
	}
	return 0;
}

int DirectDeActive1()
{
	//if (keyboard) keyboard->Unacquire();
	return 0;
}


void DMOUSE(int &x,int &y,WORD &Left,WORD &Right)
{
	HRESULT hr;
	DIDEVICEOBJECTDATA dod;
	DWORD de=1;
	while (TRUE)
	{
		r=mouse->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),&dod,&de,0);
		if (FAILED(r))
		{
			r=mouse->Acquire();
			mouse->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),&dod,&de,0);
		}
		if (FAILED(r) || de==0) break;
		switch (dod.dwOfs)
		{
		case DIMOFS_X:x+=dod.dwData;break;
		case DIMOFS_Y:y+=dod.dwData;break;
		case DIMOFS_BUTTON0:
			if (dod.dwData & 0x80) Left=1;
			else Left=0;
			break;
		case DIMOFS_BUTTON1:
			if (dod.dwData & 0x80) Right=1;
			else Right=0;
			break;
		}
	}
}

char* DINPUT(HWND h)
{
	HRESULT r;
	static char key[256];
	r=keyboard->GetDeviceState(sizeof(key),&key);
	if (r!=DI_OK)
	{
		r = keyboard->Acquire();
        while( r == DIERR_INPUTLOST || 
                   r == E_ACCESSDENIED  ) 
        {
                r = keyboard->Acquire();
				r=keyboard->GetDeviceState(sizeof(key),&key);
        }
	}
	return key;
}

char* Klavi(int kl)
{
	return KlaviKod1(kl);
}


